# Harness NextGen Software Delivery Platform API Reference

The Harness Software Delivery Platform uses OpenAPI Specification v3.0. Harness constantly improves these APIs. Please be aware that some improvements could cause breaking changes.
# Introduction 

  The Harness API allows you to integrate and use all the services and modules we provide on the Harness Platform. If you use client-side SDKs, Harness functionality can be integrated with your client-side automation, helping you reduce manual efforts and deploy code faster.

  For more information about how Harness works, read our [documentation](https://developer.harness.io/docs/getting-started) or visit the [Harness Developer Hub](https://developer.harness.io/).

## How it works

  The Harness API is a RESTful API that uses standard HTTP verbs. You can send requests in JSON, YAML, or form-data format. The format of the response matches the format of your request. You must send a single request at a time and ensure that you include your authentication key. For more information about this, go to [Authentication](#section/Introduction/Authentication).

## Get started

  Before you start integrating, get to know our API better by reading the following topics:

  * [Harness key concepts](https://developer.harness.io/docs/getting-started/learn-harness-key-concepts/)
  * [Authentication](#section/Introduction/Authentication)
  * [Requests and responses](#section/Introduction/Requests-and-Responses)
  * [Common Parameters](#section/Introduction/Common-Parameters-Beta)
  * [Status Codes](#section/Introduction/Status-Codes)
  * [Errors](#tag/Error-Response)
  * [Versioning](#section/Introduction/Versioning-Beta)
  * [Pagination](/#section/Introduction/Pagination-Beta)

  The methods you need to integrate with depend on the functionality you want to use. Work with  your Harness Solutions Engineer to determine which methods you need.

## Authentication

To authenticate with the Harness API, you need to:
  1. Generate an API token on the Harness Platform.
  2. Send the API token you generate in the `x-api-key` header in each request.

### Generate an API token

To generate an API token, complete the following steps:
  1. Go to the [Harness Platform](https://app.harness.io/).
  2. On the left-hand navigation, click **My Profile**.
  3. Click **+API Key**, enter a name for your key and then click **Save**.
  4. Within the API Key tile, click **+Token**.
  5. Enter a name for your token and click **Generate Token**.
**Important**: Make sure to save your token securely. Harness does not store the API token for future reference, so make sure to save your token securely before you leave the page.

### Send the API token in your requests

Send the token you created in the Harness Platform in the x-api-key header. For example:
  `x-api-key: YOUR_API_KEY_HERE`

## Requests and Responses

  The structure for each request and response is outlined in the API documentation. We have examples in JSON and YAML for every request and response. You can use our online editor to test the examples.

## Common Parameters [Beta]

| Field Name | Type    | Default | Description    |
|------------|---------|---------|----------------|
| identifier | string  | none    | URL-friendly version of the name, used to identify a resource within it's scope and so needs to be unique within the scope.                                                                                                            |
| name       | string  | none    | Human-friendly name for the resource.                                                                                       |
| org        | string  | none    | Limit to provided org identifiers.                                                                                                                     |
| project    | string  | none    | Limit to provided project identifiers.                                                                                                                 |
| description| string  | none    | More information about the specific resource.                                                                                    |
| tags       | map[string]string  | none    | List of labels applied to the resource.                                                                                                                         |
| order      | string  | desc    | Order to use when sorting the specified fields. Type: enum(asc,desc).                                                                                                                                     |
| sort       | string  | none    | Fields on which to sort. Note: Specify the fields that you want to use for sorting. When doing so, consider the operational overhead of sorting fields. |
| limit      | int     | 30      | Pagination: Number of items to return.                                                                                                                 |
| page       | int     | 1       | Pagination page number strategy: Specify the page number within the paginated collection related to the number of items in each page.                  |
| created    | int64   | none    | Unix timestamp that shows when the resource was created (in milliseconds).                                                               |
| updated    | int64   | none    | Unix timestamp that shows when the resource was last edited (in milliseconds).                                                           |


## Status Codes

  Harness uses conventional HTTP status codes to indicate the status of an API request. 
  Generally, 2xx responses are reserved for success and 4xx status codes are reserved for failures. A 5xx response code indicates an error on the Harness server.

  | Error Code  | Description |
  |-------------|-------------|
  | 200         |     OK      |
  | 201         |   Created   |
  | 202         |   Accepted  |
  | 204         |  No Content |
  | 400         | Bad Request |
  | 401         | Unauthorized |
  | 403         | Forbidden |
  | 412         | Precondition Failed |
  | 415         | Unsupported Media Type |
  | 500         | Server Error |

  To view our error response structures, go [here](#tag/Error-Response).

## Versioning [Beta]

### Harness Version
  The current version of our Beta APIs is yet to be announced. The version number will use the date-header format and will be valid only for our Beta APIs.

### Generation
  All our beta APIs are versioned as a Generation, and this version is included in the path to every API resource. For example, v1 beta APIs begin with `app.harness.io/v1/`, where v1 is the API Generation.

  The version number represents the core API and does not change frequently. The version number changes only if there is a significant departure from the basic underpinnings of the existing API. For example, when Harness performs a system-wide refactoring of core concepts or resources.

## Pagination [Beta]

We use pagination to place limits on the number of responses associated with list endpoints. Pagination is achieved by the use of limit query parameters. The limit defaults to 30. Its maximum value is 100.

Following are the pagination headers supported in the response bodies of paginated APIs:
  1. X-Total-Elements : Indicates the total number of entries in a paginated response.
  2. X-Page-Number : Indicates the page number currently returned for a paginated response.
  3. X-Page-Size : Indicates the number of entries per page for a paginated response.

For example:

  ```
X-Total-Elements : 30
X-Page-Number : 0
X-Page-Size : 10
  ```


Version: 1.0

## Servers

Harness host URL
```
https://app.harness.io
```

Vanity URL
```
https://{vanity}
```

Variables:
- `vanity`
Default: "app.harness.io"

## Security

### x-api-key

API key is a token provided while making the API calls. This is used to authenticate the client at the exposed endpoint.

Type: apiKey
In: header
Name: x-api-key

## Download OpenAPI description

[Harness NextGen Software Delivery Platform API Reference](https://apidocs.harness.io/_bundle/index.yaml)

## Organization

Create and manage organizations in your account. You use organizations to group together related projects. For example, you can use an organization to group together projects within a business unit or division.

### Create an organization [Beta]

 - [POST /v1/orgs](https://apidocs.harness.io/organization/create-organization.md): Creates a new organization.

### List organizations [Beta]

 - [GET /v1/orgs](https://apidocs.harness.io/organization/get-organizations.md): Retrieves the information of the organizations.

### Retrieve an organization [Beta]

 - [GET /v1/orgs/{org}](https://apidocs.harness.io/organization/get-organization.md): Retrieves the information of the organization with the matching organization identifier.

### Update an organization [Beta]

 - [PUT /v1/orgs/{org}](https://apidocs.harness.io/organization/update-organization.md): Updates the information of the organization with the matching organization identifier.

### Delete an organization [Beta]

 - [DELETE /v1/orgs/{org}](https://apidocs.harness.io/organization/delete-organization.md): Deletes the information of the organization with the matching organization identifier.

### List Organizations by filter

 - [GET /ng/api/organizations](https://apidocs.harness.io/organization/getorganizationlist.md): List all Organizations matching the given search criteria.

### Create an Organization

 - [POST /ng/api/organizations](https://apidocs.harness.io/organization/postorganization.md): Creates a new Organization.

### List Organization details

 - [GET /ng/api/organizations/{identifier}](https://apidocs.harness.io/organization/getorganization.md): Lists Organization details using an Account and Organization ID.

### Update an Organization

 - [PUT /ng/api/organizations/{identifier}](https://apidocs.harness.io/organization/putorganization.md): Updates Organization settings.

### Delete an Organization

 - [DELETE /ng/api/organizations/{identifier}](https://apidocs.harness.io/organization/deleteorganization.md): Deletes Organization for the given ID.

## Project [Beta]

This contains APIs for projects.

### Create a project

 - [POST /v1/orgs/{org}/projects](https://apidocs.harness.io/org-project/create-org-scoped-project.md): Creates a new project

### List projects

 - [GET /v1/orgs/{org}/projects](https://apidocs.harness.io/org-project/get-org-scoped-projects.md): Retrieves the information of the projects.

### Retrieve a project

 - [GET /v1/orgs/{org}/projects/{project}](https://apidocs.harness.io/org-project/get-org-scoped-project.md): Retrieves the information of the project with the matching project identifier.

### Update a project

 - [PUT /v1/orgs/{org}/projects/{project}](https://apidocs.harness.io/org-project/update-org-scoped-project.md): Updates the information of the project with the matching project identifier.

### Delete a project

 - [DELETE /v1/orgs/{org}/projects/{project}](https://apidocs.harness.io/org-project/delete-org-scoped-project.md): Deletes the information of the project with the matching project identifier.

## Project

This contains APIs related to Project as defined in Harness

### List all Projects for a user

 - [GET /ng/api/projects](https://apidocs.harness.io/project/getprojectlist.md): Lists all Projects the user is a member of by using the user's API key token.

### Create a Project

 - [POST /ng/api/projects](https://apidocs.harness.io/project/postproject.md): Creates a new Harness Project.

### List Project details

 - [GET /ng/api/projects/{identifier}](https://apidocs.harness.io/project/getproject.md): Lists a Project's details for the given ID.

### Update a Project

 - [PUT /ng/api/projects/{identifier}](https://apidocs.harness.io/project/putproject.md): Updates Project details for the given ID.

### Delete a Project

 - [DELETE /ng/api/projects/{identifier}](https://apidocs.harness.io/project/deleteproject.md): Deletes a Project corresponding to the given ID.

### List user's project with support to filter by multiple organizations

 - [GET /ng/api/projects/list](https://apidocs.harness.io/project/getprojectlistwithmultiorgfilter.md)

## Account Secrets [Beta]

This contains APIs for account-scoped secrets.

### Create a secret

 - [POST /v1/secrets](https://apidocs.harness.io/account-secret/create-account-scoped-secret.md): Creates a new secret

### List secrets

 - [GET /v1/secrets](https://apidocs.harness.io/account-secret/get-account-scoped-secrets.md): Retrieves the information of the secrets.

### Validate secret reference

 - [POST /v1/secrets/validate-secret-ref](https://apidocs.harness.io/account-secret/validate-account-secret-ref.md): Validates if the secret at the secretManager path can be referenced

### Retrieve a secret

 - [GET /v1/secrets/{secret}](https://apidocs.harness.io/account-secret/get-account-scoped-secret.md): Retrieves the information of the secret.

### Deletes a secret

 - [DELETE /v1/secrets/{secret}](https://apidocs.harness.io/account-secret/delete-account-scoped-secret.md): Deletes the information of the secret with the matching secret identifier.

### Update a secret

 - [PUT /v1/secrets/{secret}](https://apidocs.harness.io/account-secret/update-account-scoped-secret.md): Updates the information of the secret with the matching secret identifier.

## Organization Secrets [Beta]

This contains APIs for organization-scoped secrets.

### Create a secret

 - [POST /v1/orgs/{org}/secrets](https://apidocs.harness.io/org-secret/create-org-scoped-secret.md): Creates a new secret

### List secrets

 - [GET /v1/orgs/{org}/secrets](https://apidocs.harness.io/org-secret/get-org-scoped-secrets.md): Retrieves the information of the secrets.

### Validate secret reference

 - [POST /v1/orgs/{org}/secrets/validate-secret-ref](https://apidocs.harness.io/org-secret/validate-org-secret-ref.md): Validates if the secret at the secretManager path can be referenced

### Retrieve a secret

 - [GET /v1/orgs/{org}/secrets/{secret}](https://apidocs.harness.io/org-secret/get-org-scoped-secret.md): Retrieves the information of the secret.

### Delete a secret

 - [DELETE /v1/orgs/{org}/secrets/{secret}](https://apidocs.harness.io/org-secret/delete-org-scoped-secret.md): Deletes the information of the secret with the matching secret identifier.

### Update a secret

 - [PUT /v1/orgs/{org}/secrets/{secret}](https://apidocs.harness.io/org-secret/update-org-scoped-secret.md): Updates the information of the secret with the matching secret identifier.

## Project Secrets [Beta]

This contains APIs for project-scoped secrets.

### Create a secret

 - [POST /v1/orgs/{org}/projects/{project}/secrets](https://apidocs.harness.io/project-secret/create-project-scoped-secret.md): Creates a new secret

### List secrets

 - [GET /v1/orgs/{org}/projects/{project}/secrets](https://apidocs.harness.io/project-secret/get-project-scoped-secrets.md): Retrieves the information of the secrets.

### Validate secret reference

 - [POST /v1/orgs/{org}/projects/{project}/secrets/validate-secret-ref](https://apidocs.harness.io/project-secret/validate-project-secret-ref.md): Validates if the secret at the secretManager path can be referenced

### Retrieve a secret

 - [GET /v1/orgs/{org}/projects/{project}/secrets/{secret}](https://apidocs.harness.io/project-secret/get-project-scoped-secret.md): Retrieves the information of the secret.

### Delete a secret

 - [DELETE /v1/orgs/{org}/projects/{project}/secrets/{secret}](https://apidocs.harness.io/project-secret/delete-project-scoped-secret.md): Deletes the information of the secret with the matching secret identifier.

### Update a secret

 - [PUT /v1/orgs/{org}/projects/{project}/secrets/{secret}](https://apidocs.harness.io/project-secret/update-project-scoped-secret.md): Updates the information of the secret with the matching secret identifier.

## Secrets

This contains APIs related to Secrets as defined in Harness

### countSecretsForScope

 - [GET /ng/api/v2/secrets/count](https://apidocs.harness.io/secrets/countsecretsforscope.md)

### Creates a Secret at given Scope

 - [POST /ng/api/v2/secrets](https://apidocs.harness.io/secrets/postsecret.md)

### Creates a Secret File

 - [POST /ng/api/v2/secrets/files](https://apidocs.harness.io/secrets/postsecretfilev2.md)

### Get the Secret by ID and Scope

 - [GET /ng/api/v2/secrets/{identifier}](https://apidocs.harness.io/secrets/getsecretv2.md)

### Updates the Secret by ID and Scope

 - [PUT /ng/api/v2/secrets/{identifier}](https://apidocs.harness.io/secrets/putsecret.md)

### Deletes Secret by ID and Scope

 - [DELETE /ng/api/v2/secrets/{identifier}](https://apidocs.harness.io/secrets/deletesecretv2.md)

### Fetches the list of Secrets corresponding to the request's filter criteria.

 - [POST /ng/api/v2/secrets/list/secrets](https://apidocs.harness.io/secrets/listsecretsv4.md)

### Fetches the list of Secrets corresponding to the request's filter criteria.

 - [POST /ng/api/v2/secrets/list](https://apidocs.harness.io/secrets/listsecretsv3.md)

### Updates the Secret file by ID and Scope

 - [PUT /ng/api/v2/secrets/files/{identifier}](https://apidocs.harness.io/secrets/putsecretfilev2.md)

### Updates the Secret by ID and Scope via YAML

 - [PUT /ng/api/v2/secrets/{identifier}/yaml](https://apidocs.harness.io/secrets/putsecretviayaml.md)

### Validates Secret with the provided ID and Scope

 - [POST /ng/api/v2/secrets/validate](https://apidocs.harness.io/secrets/validatesecret.md)

### Checks whether the identifier is unique or not

 - [GET /ng/api/v2/secrets/validateUniqueIdentifier/{identifier}](https://apidocs.harness.io/secrets/validatesecretidentifierisunique.md)

### Fetches the list of Secrets corresponding to the request's filter criteria. (deprecated)

 - [GET /ng/api/v2/secrets](https://apidocs.harness.io/secrets/listsecretsv2.md)

### Creates a secret via YAML (deprecated)

 - [POST /ng/api/v2/secrets/yaml](https://apidocs.harness.io/secrets/postsecretviayaml.md)

## Account Connectors [Beta]

This contains APIs for Account-scoped Connectors.

### Create a Connector

 - [POST /v1/connectors](https://apidocs.harness.io/account-connector/create-account-scoped-connector.md): Creates a new connector

### List connectors

 - [GET /v1/connectors](https://apidocs.harness.io/account-connector/get-account-scoped-connectors.md): Retrieves the information of the connectors.

### Retrieve a connector

 - [GET /v1/connectors/{connector}](https://apidocs.harness.io/account-connector/get-account-scoped-connector.md): Retrieves the information of the connector with the matching connector identifier. Connector types supported are GIT, ARTIFACTORY, APP_DYNAMICS and AZURE.

### Update a connector

 - [PUT /v1/connectors/{connector}](https://apidocs.harness.io/account-connector/update-account-scoped-connector.md): Updates the information of the secret with the matching secret identifier.

### Delete a connector

 - [DELETE /v1/connectors/{connector}](https://apidocs.harness.io/account-connector/delete-account-scoped-connector.md): Deletes the information of the connector with the matching connector identifier. Connector types supported are GIT, ARTIFACTORY, APP_DYNAMICS and AZURE.

### Test a connector

 - [GET /v1/connectors/{connector}/test-connection](https://apidocs.harness.io/account-connector/test-account-scoped-connector.md): Tests connection of the connector with the matching connector identifier.

## Organization Connectors [Beta]

This contains APIs for Organization-scoped Connectors.

### Create a Connector

 - [POST /v1/orgs/{org}/connectors](https://apidocs.harness.io/org-connector/create-org-scoped-connector.md): Creates a new connector

### List connectors

 - [GET /v1/orgs/{org}/connectors](https://apidocs.harness.io/org-connector/get-org-scoped-connectors.md): Retrieves the information of the connectors.

### Retrieve a connector

 - [GET /v1/orgs/{org}/connectors/{connector}](https://apidocs.harness.io/org-connector/get-org-scoped-connector.md): Retrieves the information of the connector with the matching connector identifier. Connector types supported are GIT, ARTIFACTORY, APP_DYNAMICS and AZURE.

### Update a connector

 - [PUT /v1/orgs/{org}/connectors/{connector}](https://apidocs.harness.io/org-connector/update-org-scoped-connector.md): Updates the information of the secret with the matching secret identifier.

### Delete a connector

 - [DELETE /v1/orgs/{org}/connectors/{connector}](https://apidocs.harness.io/org-connector/delete-org-scoped-connector.md): Deletes the information of the connector with the matching connector identifier. Connector types supported are GIT, ARTIFACTORY, APP_DYNAMICS and AZURE.

### Test a connector

 - [GET /v1/orgs/{org}/connectors/{connector}/test-connection](https://apidocs.harness.io/org-connector/test-org-scoped-connector.md): Tests connection of the connector with the matching connector identifier.

## Project Connectors [Beta]

This contains APIs for Project-scoped Connectors.

### Create a Connector

 - [POST /v1/orgs/{org}/projects/{project}/connectors](https://apidocs.harness.io/project-connector/create-project-scoped-connector.md): Creates a new connector

### List connectors

 - [GET /v1/orgs/{org}/projects/{project}/connectors](https://apidocs.harness.io/project-connector/get-project-scoped-connectors.md): Retrieves the information of the connectors.

### Retrieve a connector

 - [GET /v1/orgs/{org}/projects/{project}/connectors/{connector}](https://apidocs.harness.io/project-connector/get-project-scoped-connector.md): Retrieves the information of the connector with the matching connector identifier. Connector types supported are GIT, ARTIFACTORY, APP_DYNAMICS and AZURE.

### Update a connector

 - [PUT /v1/orgs/{org}/projects/{project}/connectors/{connector}](https://apidocs.harness.io/project-connector/update-project-scoped-connector.md): Updates the information of the secret with the matching secret identifier.

### Delete a connector

 - [DELETE /v1/orgs/{org}/projects/{project}/connectors/{connector}](https://apidocs.harness.io/project-connector/delete-project-scoped-connector.md): Deletes the information of the connector with the matching connector identifier. Connector types supported are GIT, ARTIFACTORY, APP_DYNAMICS and AZURE.

### Test a connector

 - [GET /v1/orgs/{org}/projects/{project}/connectors/{connector}/test-connection](https://apidocs.harness.io/project-connector/test-project-scoped-connector.md): Tests connection of the connector with the matching connector identifier.

## Connectors

This contains APIs related to Connectors as defined in Harness

### Fetches the list of CCM K8S Connectors corresponding to the request's filter criteria.

 - [POST /ng/api/connectors/ccmK8sList](https://apidocs.harness.io/connectors/getccmk8sconnectorlist.md)

### Update a Connector

 - [PUT /ng/api/connectors](https://apidocs.harness.io/connectors/updateconnector.md): Updates a Connector for the given ID.

### Create a Connector

 - [POST /ng/api/connectors](https://apidocs.harness.io/connectors/createconnector.md): Creates a new Harness Connector.

### Return Connector details

 - [GET /ng/api/connectors/{identifier}](https://apidocs.harness.io/connectors/getconnector.md): Returns the Connector's details for the given Account and Connector ID.

### Delete a Connector

 - [DELETE /ng/api/connectors/{identifier}](https://apidocs.harness.io/connectors/deleteconnector.md): Deletes a Connector for the given ID.

### List all the configured field values for the given Connector type.

 - [GET /ng/api/connectors/fieldValues](https://apidocs.harness.io/connectors/getallallowedfieldvalues.md): Returns all the configured field values for the given Connector type, which can be used during connector creation.

### Lists all Connectors for an account

 - [GET /ng/api/connectors/catalogue](https://apidocs.harness.io/connectors/getconnectorcatalogue.md): Lists all the Connectors for the given Account ID.

### Gets the connector's statistics by Account Identifier, Project Identifier and Organization Identifier

 - [GET /ng/api/connectors/stats](https://apidocs.harness.io/connectors/getconnectorstatistics.md)

### Get list of GCP Projects

 - [GET /ng/api/connectors/{connectorRef}/gcp-projects](https://apidocs.harness.io/connectors/getgcpprojects.md): Returns the list of GCP project IDs that the connector has access to.

### Fetches the list of Connectors corresponding to the request's filter criteria.

 - [POST /ng/api/connectors/listV2](https://apidocs.harness.io/connectors/getconnectorlistv2.md)

### Get list of Connectors by FQN

 - [POST /ng/api/connectors/listbyfqn](https://apidocs.harness.io/connectors/listconnectorbyfqn.md): Lists all Connectors for an Account by Fully Qualified Name (FQN) with a limit of max 1000 FQNs per request.

### Test Harness Connector connection with third-party tool

 - [POST /ng/api/connectors/testConnection/{identifier}](https://apidocs.harness.io/connectors/gettestconnectionresult.md): Tests if a Harness Connector can successfully connect Harness to a third-party tool.

### Test Git Connector sync with repo

 - [POST /ng/api/connectors/testGitRepoConnection/{identifier}](https://apidocs.harness.io/connectors/gettestgitrepoconnectionresult.md): Tests if a Git Repo Connector can successfully connect Harness to a Git provider.

### Test a Harness Connector

 - [GET /ng/api/connectors/validateUniqueIdentifier](https://apidocs.harness.io/connectors/validatetheidentifierisunique.md): Tests if a Connector can successfully connect Harness to a third-party tool using the an Account and Connector ID.

### List all Connectors using filters (deprecated)

 - [GET /ng/api/connectors](https://apidocs.harness.io/connectors/getconnectorlist.md): Lists all the Connectors matching the specified filters.

### Get the Template URL of connector (deprecated)

 - [POST /ng/api/connectors/getceawstemplateurl](https://apidocs.harness.io/connectors/getceawstemplate.md)

## GoogleSecretManagerConnector

This contains APIs specific to Google Secret Manager Connector as defined in Harness

### Get list of GCP Regions

 - [GET /ng/api/google-secret-manager-connector/gcp-regions](https://apidocs.harness.io/googlesecretmanagerconnector/getgcpregions.md): Lists all GCP Regions

## Account Roles [Beta]

This contains APIs for Account-scoped Roles.

### List Roles

 - [GET /v1/roles](https://apidocs.harness.io/account-roles/list-roles-acc.md): Returns a list of Roles present in the Account scope.

### Create a Role

 - [POST /v1/roles](https://apidocs.harness.io/account-roles/create-role-acc.md): Creates a custom Role in the Account scope.

### Retrieve a Role

 - [GET /v1/roles/{role}](https://apidocs.harness.io/account-roles/get-role-acc.md): Retrieves a Role from Account scope.

### Update a Role

 - [PUT /v1/roles/{role}](https://apidocs.harness.io/account-roles/update-role-acc.md): Updates a Role from Account scope.

### Delete a Role

 - [DELETE /v1/roles/{role}](https://apidocs.harness.io/account-roles/delete-role-acc.md): Deletes a custom Role from Account scope.

### Get roles count for an account

 - [GET /v1/roles/count](https://apidocs.harness.io/account-roles/get-roles-count.md): Get roles count for an account.

## Organization Roles [Beta]

This contains APIs for Organization-scoped Roles.

### List Roles

 - [GET /v1/orgs/{org}/roles](https://apidocs.harness.io/organization-roles/list-roles-org.md): Returns a list of Roles present in the Organization scope.

### Create a Role

 - [POST /v1/orgs/{org}/roles](https://apidocs.harness.io/organization-roles/create-role-org.md): Creates a custom Role in the Organization scope.

### Retrieve a Role

 - [GET /v1/orgs/{org}/roles/{role}](https://apidocs.harness.io/organization-roles/get-role-org.md): Retrieves a Role from Organization scope.

### Update a Role

 - [PUT /v1/orgs/{org}/roles/{role}](https://apidocs.harness.io/organization-roles/update-role-org.md): Updates a Role from Organization scope.

### Delete a Role

 - [DELETE /v1/orgs/{org}/roles/{role}](https://apidocs.harness.io/organization-roles/delete-role-org.md): Deletes a custom Role from Organization scope.

## Project Roles [Beta]

This contains APIs for Project-scoped Roles.

### List Roles

 - [GET /v1/orgs/{org}/projects/{project}/roles](https://apidocs.harness.io/project-roles/list-roles-project.md): Returns a list of Roles present in the Project scope.

### Create a Role

 - [POST /v1/orgs/{org}/projects/{project}/roles](https://apidocs.harness.io/project-roles/create-role-project.md): Creates a custom Role in the Project scope.

### Retrieve a Role

 - [GET /v1/orgs/{org}/projects/{project}/roles/{role}](https://apidocs.harness.io/project-roles/get-role-project.md): Retrieves a Role from Project scope.

### Update a Role

 - [PUT /v1/orgs/{org}/projects/{project}/roles/{role}](https://apidocs.harness.io/project-roles/update-role-project.md): Updates a Role from Project scope.

### Delete a Role

 - [DELETE /v1/orgs/{org}/projects/{project}/roles/{role}](https://apidocs.harness.io/project-roles/delete-role-project.md): Deletes a custom Role from Project scope.

## Roles

This contains APIs for CRUD on roles

### List Roles

 - [GET /authz/api/roles](https://apidocs.harness.io/roles/getrolelist.md): List roles in the given scope

### Create Role

 - [POST /authz/api/roles](https://apidocs.harness.io/roles/postrole.md): Create a Custom Role in a scope

### Get Role

 - [GET /authz/api/roles/{identifier}](https://apidocs.harness.io/roles/getrole.md): Get a Role by identifier

### Update Role

 - [PUT /authz/api/roles/{identifier}](https://apidocs.harness.io/roles/putrole.md): Update a Custom Role by identifier

### Delete Role

 - [DELETE /authz/api/roles/{identifier}](https://apidocs.harness.io/roles/deleterole.md): Delete a Custom Role in a scope

## Account Resource Groups [Beta]

This contains APIs for Account-scoped Resource Groups.

### List Resource Groups

 - [GET /v1/resource-groups](https://apidocs.harness.io/account-resource-groups/list-resource-groups-acc.md): Returns a list of Resource Groups present in the Account scope.

### Create a Resource Group

 - [POST /v1/resource-groups](https://apidocs.harness.io/account-resource-groups/create-resource-group-acc.md): Creates a custom Resource Group in the Account scope.

### Retrieve a Resource Group

 - [GET /v1/resource-groups/{resource-group}](https://apidocs.harness.io/account-resource-groups/get-resource-group-acc.md): Retrieves a Resource Group from Account scope.

### Update a Resource Group

 - [PUT /v1/resource-groups/{resource-group}](https://apidocs.harness.io/account-resource-groups/update-resource-group-acc.md): Updates a Resource Group from Account scope.

### Delete a Resource Group

 - [DELETE /v1/resource-groups/{resource-group}](https://apidocs.harness.io/account-resource-groups/delete-resource-group-acc.md): Deletes a custom Resource Group from Account scope.

## Organization Resource Groups [Beta]

This contains APIs for Organization-scoped Resource Groups.

### List Resource Groups

 - [GET /v1/orgs/{org}/resource-groups](https://apidocs.harness.io/organization-resource-groups/list-resource-groups-org.md): Returns a list of Resource Groups present in the Organization scope.

### Create a Resource Group

 - [POST /v1/orgs/{org}/resource-groups](https://apidocs.harness.io/organization-resource-groups/create-resource-group-org.md): Creates a custom Resource Group in the Organization scope.

### Retrieve a Resource Group

 - [GET /v1/orgs/{org}/resource-groups/{resource-group}](https://apidocs.harness.io/organization-resource-groups/get-resource-group-org.md): Retrieves a Resource Group from Organization scope.

### Update a Resource Group

 - [PUT /v1/orgs/{org}/resource-groups/{resource-group}](https://apidocs.harness.io/organization-resource-groups/update-resource-group-org.md): Updates a Resource Group from Organization scope.

### Delete a Resource Group

 - [DELETE /v1/orgs/{org}/resource-groups/{resource-group}](https://apidocs.harness.io/organization-resource-groups/delete-resource-group-org.md): Deletes a custom Resource Group from Organization scope.

## Project Resource Groups [Beta]

This contains APIs for Project-scoped Resource Groups.

### List Resource Groups

 - [GET /v1/orgs/{org}/projects/{project}/resource-groups](https://apidocs.harness.io/project-resource-groups/list-resource-groups-project.md): Returns a list of Resource Groups present in the Project scope.

### Create a Resource Group

 - [POST /v1/orgs/{org}/projects/{project}/resource-groups](https://apidocs.harness.io/project-resource-groups/create-resource-group-project.md): Creates a custom Resource Group in the Project scope.

### Retrieve a Resource Group

 - [GET /v1/orgs/{org}/projects/{project}/resource-groups/{resource-group}](https://apidocs.harness.io/project-resource-groups/get-resource-group-project.md): Retrieves a Resource Group from Project scope.

### Update a Resource Group

 - [PUT /v1/orgs/{org}/projects/{project}/resource-groups/{resource-group}](https://apidocs.harness.io/project-resource-groups/update-resource-group-project.md): Updates a Resource Group from Project scope.

### Delete a Resource Group

 - [DELETE /v1/orgs/{org}/projects/{project}/resource-groups/{resource-group}](https://apidocs.harness.io/project-resource-groups/delete-resource-group-project.md): Deletes a custom Resource Group from Project scope.

## Filter Resource Groups [Beta]

This contains the filter endpoint for Resource Groups.

### Filter Resource Groups

 - [POST /v1/resource-groups/filter](https://apidocs.harness.io/filter-resource-groups/filter-resource-groups.md): Returns a list of Resource Groups based on filter criteria.

## Harness Resource Group

This contains APIs specific to the Harness Resource Group

### List Resource Groups

 - [GET /authz/api/v2/resourcegroup](https://apidocs.harness.io/harness-resource-group/getresourcegrouplistv2.md): Get list of resource groups

### Create Resource Group

 - [POST /authz/api/v2/resourcegroup](https://apidocs.harness.io/harness-resource-group/createresourcegroupv2.md): Create a resource group

### Get Resource Group

 - [GET /authz/api/v2/resourcegroup/{identifier}](https://apidocs.harness.io/harness-resource-group/getresourcegroupv2.md): Get a resource group by identifier

### Update Resource Group

 - [PUT /authz/api/v2/resourcegroup/{identifier}](https://apidocs.harness.io/harness-resource-group/updateresourcegroupv2.md): Update a resource group

### Delete Resource Group

 - [DELETE /authz/api/v2/resourcegroup/{identifier}](https://apidocs.harness.io/harness-resource-group/deleteresourcegroupv2.md): Delete a resource group

### List Resource Groups by filter

 - [POST /authz/api/v2/resourcegroup/filter](https://apidocs.harness.io/harness-resource-group/getfilterresourcegrouplistv2.md): This fetches a filtered list of Resource Groups

## Zendesk

This contains APIs specific to the creation of zendesk ticket

### create zendesk ticket for given user

 - [POST /authz/api/zendesk](https://apidocs.harness.io/zendesk/createzendeskticket.md)

### get short live token for Coveo

 - [GET /authz/api/zendesk/token](https://apidocs.harness.io/zendesk/getcoveotoken.md)

## Account Role Assignments [Beta]

This contains APIs for Account-scoped Role Assignments.

### List role assignments

 - [GET /v1/role-assignments](https://apidocs.harness.io/account-role-assignments/get-account-scoped-role-assignments.md): Retrieves the information of the role assignments

### Create a role assignment

 - [POST /v1/role-assignments](https://apidocs.harness.io/account-role-assignments/create-account-scoped-role-assignments.md): Create a role assignment

### Retrieve a role assignment

 - [GET /v1/role-assignments/{role-assignment}](https://apidocs.harness.io/account-role-assignments/get-account-scoped-role-assignment.md): Retrieves the information of the role assignment with the matching role assignment identifier.

### Delete a role assignment

 - [DELETE /v1/role-assignments/{role-assignment}](https://apidocs.harness.io/account-role-assignments/delete-account-scoped-role-assignment.md): Deletes the information of the role assignment with the matching role assignment identifier.

### Get role assignments count for an account

 - [GET /v1/role-assignments/count](https://apidocs.harness.io/account-role-assignments/get-role-assignments-count.md): Get role assignments count for an account.

## Organization Role Assignments [Beta]

This contains APIs for Organization-scoped Role Assignments.

### List role assignments

 - [GET /v1/orgs/{org}/role-assignments](https://apidocs.harness.io/org-role-assignments/get-org-scoped-role-assignments.md): Retrieves the information of the role assignments

### Create a role assignment

 - [POST /v1/orgs/{org}/role-assignments](https://apidocs.harness.io/org-role-assignments/create-org-scoped-role-assignments.md): Create a role assignment

### Retrieve a role assignment

 - [GET /v1/orgs/{org}/role-assignments/{role-assignment}](https://apidocs.harness.io/org-role-assignments/get-org-scoped-role-assignment.md): Retrieves the information of the role assignment with the matching role assignment identifier.

### Delete a role assignment

 - [DELETE /v1/orgs/{org}/role-assignments/{role-assignment}](https://apidocs.harness.io/org-role-assignments/delete-org-scoped-role-assignment.md): Deletes the information of the role assignment with the matching role assignment identifier.

## Project Role Assignments [Beta]

This contains APIs for Project-scoped Role Assignments.

### List role assignments

 - [GET /v1/orgs/{org}/projects/{project}/role-assignments](https://apidocs.harness.io/project-role-assignments/get-project-scoped-role-assignments.md): Retrieves the information of the role assignments

### Create a role assignment

 - [POST /v1/orgs/{org}/projects/{project}/role-assignments](https://apidocs.harness.io/project-role-assignments/create-project-scoped-role-assignments.md): Create a role assignment

### Retrieve a role assignment

 - [GET /v1/orgs/{org}/projects/{project}/role-assignments/{role-assignment}](https://apidocs.harness.io/project-role-assignments/get-project-scoped-role-assignment.md): Retrieves the information of the role assignment with the matching role assignment identifier.

### Delete a role assignment

 - [DELETE /v1/orgs/{org}/projects/{project}/role-assignments/{role-assignment}](https://apidocs.harness.io/project-role-assignments/delete-project-scoped-role-assignment.md): Deletes the information of the role assignment with the matching role assignment identifier.

## Role Assignments

This contains APIs for CRUD on role assignments

### Bulk Delete Role Assignment

 - [POST /authz/api/roleassignments/delete/batch](https://apidocs.harness.io/role-assignments/bulkdeleteroleassignment.md): Bulk delete role assignments by identifiers

### Create Role Assignments

 - [POST /authz/api/roleassignments/multi](https://apidocs.harness.io/role-assignments/postroleassignments.md): Create multiple role assignments in a scope. Returns all successfully created role assignments. Ignores failures and duplicates.

### List Role Assignments

 - [GET /authz/api/roleassignments](https://apidocs.harness.io/role-assignments/getroleassignmentlist.md): List role assignments in the given scope

### Create Role Assignment

 - [POST /authz/api/roleassignments](https://apidocs.harness.io/role-assignments/postroleassignment.md): Creates role assignment within the specified scope.

### Get Role Assignment

 - [GET /authz/api/roleassignments/{identifier}](https://apidocs.harness.io/role-assignments/getroleassignment.md): Get an existing role assignment by identifier

### Delete Role Assignment

 - [DELETE /authz/api/roleassignments/{identifier}](https://apidocs.harness.io/role-assignments/deleteroleassignment.md): Delete an existing role assignment by identifier

### List Role Assignments by filter

 - [POST /authz/api/roleassignments/filter](https://apidocs.harness.io/role-assignments/getfilteredroleassignmentlist.md): List role assignments in the scope according to the given filter

### List Aggregated Role Assignments by filter

 - [POST /authz/api/roleassignments/aggregate](https://apidocs.harness.io/role-assignments/getroleassignmentaggregatelist.md): List role assignments in the scope according to the given filter with added metadata

### List Role Assignments by scope filter

 - [POST /authz/api/roleassignments/v2/filter](https://apidocs.harness.io/role-assignments/getfilteredroleassignmentbyscopelist.md): List role assignments in the scope according to the given filter

### Validate Role Assignment

 - [POST /authz/api/roleassignments/validate](https://apidocs.harness.io/role-assignments/validateroleassignment.md): Check whether a proposed role assignment is valid.

## Access Control List

This contains the APIs to perform access control checks

### Check Permission

 - [POST /authz/api/acl](https://apidocs.harness.io/access-control-list/getaccesscontrollist.md): Check for permission on resource(s) for a principal

### Get ACL Count

 - [GET /authz/api/acl/get-acl-count](https://apidocs.harness.io/access-control-list/getaclcount.md): Returns the total number of ACL entries for the given scope

## Account Banner

This contains APIs for Account Banners.

### Retrieves the list of Banners in account scope

 - [GET /v1/banners](https://apidocs.harness.io/account-banner/get-account-scoped-banners.md): Retrieves the list of Banners in account scope

### Creates a new Banner in account scope

 - [POST /v1/banners](https://apidocs.harness.io/account-banner/create-account-scoped-banners.md): Creates a new Banner in Account Scope.

### Validate if the specified Banner identifier is available for use in account scope

 - [GET /v1/banners/validate-unique-identifier/{bannerId}](https://apidocs.harness.io/account-banner/validate-account-scoped-banner-identifier.md): Validate if the specified BannerDTO identifier is available for use in account scope

### Check for a current account max 5 banners are enabled or not

 - [GET /v1/banners/allowed](https://apidocs.harness.io/account-banner/banners-allowed.md): Check for a current account max 5 banners are enabled or not.

### Updates the specified Banner in account scope

 - [PUT /v1/banners/{banner}](https://apidocs.harness.io/account-banner/update-account-scoped-banner.md): Updates the specified Banner in account scope

### Deletes the specified Banner in account scope

 - [DELETE /v1/banners/{banner}](https://apidocs.harness.io/account-banner/delete-account-scoped-banner.md): Deletes the specified Banner in account scope

### Return Active Banners

 - [GET /v1/banners/active](https://apidocs.harness.io/account-banner/get-account-scoped-active-banners.md): This API endpoint will return max 5 banners as that is the enabled banners count.

### Retrieves the list of Banners in account scope

 - [GET /v1/banners](https://apidocs.harness.io/account-banner/get-account-scoped-banners.md): Retrieves the list of Banners in account scope

### Creates a new Banner in account scope

 - [POST /v1/banners](https://apidocs.harness.io/account-banner/create-account-scoped-banners.md): Creates a new Banner in Account Scope.

### Validate if the specified Banner identifier is available for use in account scope

 - [GET /v1/banners/validate-unique-identifier/{bannerId}](https://apidocs.harness.io/account-banner/validate-account-scoped-banner-identifier.md): Validate if the specified BannerDTO identifier is available for use in account scope

### Check for a current account max 5 banners are enabled or not

 - [GET /v1/banners/allowed](https://apidocs.harness.io/account-banner/banners-allowed.md): Check for a current account max 5 banners are enabled or not.

### Updates the specified Banner in account scope

 - [PUT /v1/banners/{banner}](https://apidocs.harness.io/account-banner/update-account-scoped-banner.md): Updates the specified Banner in account scope

### Deletes the specified Banner in account scope

 - [DELETE /v1/banners/{banner}](https://apidocs.harness.io/account-banner/delete-account-scoped-banner.md): Deletes the specified Banner in account scope

### Return Active Banners

 - [GET /v1/banners/active](https://apidocs.harness.io/account-banner/get-account-scoped-active-banners.md): This API endpoint will return max 5 banners as that is the enabled banners count.

## Account Licensed Modules

This contains APIs for Account Licensed Modules.

### Get Licensed Modules for an account

 - [GET /v1/licensedModules](https://apidocs.harness.io/account-licensed-modules/get-account-licensed-modules.md): Get Licensed Modules for an account

## Account License Type

### Retrieve type of licenses for an account

 - [GET /v1/subscription/{accountIdentifier}](https://apidocs.harness.io/account-license-type/get-license-type.md)

## Account Webhooks

This contains APIs for Account Webhooks.

### Lists all the Webhooks at Account level

 - [POST /v1/webhooks/list](https://apidocs.harness.io/account-webhooks/list-account-webhooks.md): Lists webhooks

### Create a webhook at Account level

 - [POST /v1/webhooks](https://apidocs.harness.io/account-webhooks/create-account-webhooks.md): Create webhooks at account level

### Fetch Webhook at Account level

 - [GET /v1/webhooks/{webhook}](https://apidocs.harness.io/account-webhooks/get-account-webhook.md): Fetch Webhook at Account level

### Updates a Webhook at Account level

 - [PUT /v1/webhooks/{webhook}](https://apidocs.harness.io/account-webhooks/update-account-webhook.md): Updates a Webhook at Account level

### Deletes a Webhook at account level

 - [DELETE /v1/webhooks/{webhook}](https://apidocs.harness.io/account-webhooks/delete-account-webhook.md): Deletes a Webhook at account level

## AccountSetting

This contains APIs related to Account Settings as defined in Harness

### Get the AccountSetting by accountIdentifier

 - [GET /ng/api/account-setting](https://apidocs.harness.io/accountsetting/getaccountsetting.md)

### Updates account settings

 - [PUT /ng/api/account-setting](https://apidocs.harness.io/accountsetting/updateaccountsetting.md)

### Get the AccountSetting by accountIdentifier

 - [GET /ng/api/account-setting/list](https://apidocs.harness.io/accountsetting/listaccountsetting.md)

## Accounts

This contains APIs related to accounts as defined in Harness

### Gets an account

 - [GET /ng/api/accounts/{accountIdentifier}](https://apidocs.harness.io/accounts/getaccountng.md)

### Returns a list of all enabled feature flags in the account

 - [GET /ng/api/accounts/feature-flags/{accountIdentifier}](https://apidocs.harness.io/accounts/enabledfeatureflags.md)

### Checks if immutable delegate is enabled for account

 - [GET /ng/api/accounts/{accountIdentifier}/immutable-delegate-enabled](https://apidocs.harness.io/accounts/isimmutabledelegateenabled.md)

### License update from UI

 - [PUT /ng/api/accounts/license/update/{accountIdentifier}](https://apidocs.harness.io/accounts/licenseupdatefromuing.md)

### Update Account Name

 - [PUT /ng/api/accounts/{accountIdentifier}/name](https://apidocs.harness.io/accounts/updateaccountnameng.md)

### Update Default Experience

 - [PUT /ng/api/accounts/{accountIdentifier}/default-experience](https://apidocs.harness.io/accounts/updateaccountdefaultexperienceng.md)

### Accounts#DeleteAccountData

 - [DELETE /sto/api/v2/accounts/{id}/data](https://apidocs.harness.io/accounts/accounts_deleteaccountdata.md): Delete all account data

## Analyze Account Access Policy

### Analyze access policies within account

 - [POST /v1/analyze-access-policies](https://apidocs.harness.io/analyze-account-access-policy/analyze-account-access-policies.md): Analyze access policies within account

## Analyze Organization Access Policy

### Analyze access policies within a organization

 - [POST /v1/orgs/{org}/analyze-access-policies](https://apidocs.harness.io/analyze-organization-access-policy/analyze-org-access-policies.md): Analyze access policies within a organization

## Analyze Project Access Policy

### Analyze access policies within a project

 - [POST /v1/orgs/{org}/projects/{project}/analyze-access-policies](https://apidocs.harness.io/analyze-project-access-policy/analyze-project-access-policies.md): Analyze access policies within a project

## ApiKey

This fetches API keys defined in Harness

### Fetches the list of API Keys corresponding to the request's filter criteria.

 - [GET /ng/api/apikey](https://apidocs.harness.io/apikey/listapikeys_1.md)

### Creates an API key

 - [POST /ng/api/apikey](https://apidocs.harness.io/apikey/createapikey.md)

### Updates API Key for the provided ID

 - [PUT /ng/api/apikey/{identifier}](https://apidocs.harness.io/apikey/updateapikey.md)

### Deletes the API Key corresponding to the provided ID.

 - [DELETE /ng/api/apikey/{identifier}](https://apidocs.harness.io/apikey/deleteapikey.md)

### Fetches the API Keys details corresponding to the provided ID and Scope.

 - [GET /ng/api/apikey/aggregate/{identifier}](https://apidocs.harness.io/apikey/getaggregatedapikey.md)

### Fetches the list of Aggregated API Keys corresponding to the request's filter criteria.

 - [GET /ng/api/apikey/aggregate](https://apidocs.harness.io/apikey/listapikeys.md)

## Audit

This contains APIs related to Audit as defined in Harness

### List Audit Events

 - [POST /audit/api/audits/list](https://apidocs.harness.io/audit/getauditeventlist.md)

### List Audit Events

 - [POST /audit/api/audits/listV2](https://apidocs.harness.io/audit/getauditeventlistv2.md)

## AuditFilters

This contains APIs related to Filter of type Audit as defined in Harness

### Get the list of Filters of type Audit satisfying the criteria (if any) in the request

 - [GET /audit/api/auditFilters](https://apidocs.harness.io/auditfilters/getauditfilterlist.md)

### Updates the Filter of type Audit

 - [PUT /audit/api/auditFilters](https://apidocs.harness.io/auditfilters/updateauditfilter.md)

### Creates a Filter

 - [POST /audit/api/auditFilters](https://apidocs.harness.io/auditfilters/postauditfilter.md)

### Gets a Filter of type Audit by identifier

 - [GET /audit/api/auditFilters/{identifier}](https://apidocs.harness.io/auditfilters/getauditfilter.md)

### Delete a Filter of type Audit by identifier

 - [DELETE /audit/api/auditFilters/{identifier}](https://apidocs.harness.io/auditfilters/deleteauditfilter.md)

## Authentication Settings

This contains APIs related to Authentication settings as defined in Harness

### Return configured Ldap settings for the account

 - [GET /ng/api/authentication-settings/ldap/settings](https://apidocs.harness.io/authentication-settings/getldapsettings.md): Returns configured Ldap settings and its details for the account.

### Updates Ldap setting

 - [PUT /ng/api/authentication-settings/ldap/settings](https://apidocs.harness.io/authentication-settings/updateldapsettings.md): Updates configured Ldap settings along with the user, group queries.

### Create Ldap setting

 - [POST /ng/api/authentication-settings/ldap/settings](https://apidocs.harness.io/authentication-settings/createldapsettings.md): Creates Ldap settings along with the user, group queries.

### Delete Ldap settings

 - [DELETE /ng/api/authentication-settings/ldap/settings](https://apidocs.harness.io/authentication-settings/deleteldapsettings.md): Delete configured Ldap settings on this account.

### Delete SAML meta data

 - [DELETE /ng/api/authentication-settings/delete-saml-metadata](https://apidocs.harness.io/authentication-settings/deletesamlmetadata.md): Deletes SAML metadata for the given Account ID.

### Delete SAML meta data for given SAML sso id

 - [DELETE /ng/api/authentication-settings/saml-metadata/{samlSSOId}/delete](https://apidocs.harness.io/authentication-settings/deletesamlmetadataforsamlssoid.md): Deletes SAML metadata for the given Account and SAML sso id

### Update authentication enabled or not for given SAML setting

 - [PUT /ng/api/authentication-settings/saml-metadata-upload/{samlSSOId}/authentication](https://apidocs.harness.io/authentication-settings/enabledisableauthenticationforsamlsetting.md): Updates if authentication is enabled or not for given SAML setting in Account ID.

### Gets authentication settings for the given Account ID

 - [GET /ng/api/authentication-settings](https://apidocs.harness.io/authentication-settings/getauthenticationsettings.md): Gets authentication settings for the given Account ID.

### Gets authentication settings version 2 for the given Account ID

 - [GET /ng/api/authentication-settings/v2](https://apidocs.harness.io/authentication-settings/getauthenticationsettingsv2.md): Gets authentication settings version 2 for the given Account ID.

### Get password strength

 - [GET /ng/api/authentication-settings/login-settings/password-strength](https://apidocs.harness.io/authentication-settings/getpasswordstrengthsettings.md): Gets password strength for the given Account ID.

### Test SAML connectivity

 - [GET /ng/api/authentication-settings/saml-login-test](https://apidocs.harness.io/authentication-settings/getsamllogintest.md): Tests SAML connectivity for the given Account ID.

### Test SAML connectivity

 - [GET /ng/api/authentication-settings/saml-login-test/{samlSSOId}](https://apidocs.harness.io/authentication-settings/getsamllogintestv2.md): Tests SAML connectivity for the given Account ID and SAML setting.

### Delete OAuth Setting

 - [DELETE /ng/api/authentication-settings/oauth/remove-mechanism](https://apidocs.harness.io/authentication-settings/removeoauthmechanism.md): Deletes OAuth settings for a given Account ID.

### Enable/disable public access at account level

 - [PUT /ng/api/authentication-settings/public-access](https://apidocs.harness.io/authentication-settings/setpublicaccess.md): Enable/disable public access for the given Account ID.

### Set session timeout at account level

 - [PUT /ng/api/authentication-settings/session-timeout-account-level](https://apidocs.harness.io/authentication-settings/setsessiontimeoutataccountlevel.md): Sets session timeout of all users for the given Account ID.

### Set two factor authorization

 - [PUT /ng/api/authentication-settings/two-factor-admin-override-settings](https://apidocs.harness.io/authentication-settings/settwofactorauthataccountlevel.md): Sets Two-Factor authorization for the given Account ID.

### Update Auth mechanism

 - [PUT /ng/api/authentication-settings/update-auth-mechanism](https://apidocs.harness.io/authentication-settings/updateauthmechanism.md): Updates the authentication mechanism for the given Account ID.

### Update Oauth providers

 - [PUT /ng/api/authentication-settings/oauth/update-providers](https://apidocs.harness.io/authentication-settings/updateoauthproviders.md): Updates OAuth providers for the given Account ID.

### Update SAML metadata

 - [PUT /ng/api/authentication-settings/saml-metadata-upload](https://apidocs.harness.io/authentication-settings/updatesamlmetadata.md): Updates SAML metadata of the SAML configuration configured for an account

### Upload SAML metadata

 - [POST /ng/api/authentication-settings/saml-metadata-upload](https://apidocs.harness.io/authentication-settings/uploadsamlmetadata.md): Updates the SAML metadata for the given Account ID.

### Update SAML metadata for a given SAML SSO Id

 - [PUT /ng/api/authentication-settings/saml-metadata-upload/{samlSSOId}](https://apidocs.harness.io/authentication-settings/updatesamlmetadataforsamlssoid.md): Updates SAML metadata of the SAML configuration with given SSO Id, configured for an account

### Updates the whitelisted domains

 - [PUT /ng/api/authentication-settings/whitelisted-domains](https://apidocs.harness.io/authentication-settings/updatewhitelisteddomains.md): Updates whitelisted domains configured for an account.

### Upload SAML metadata

 - [POST /ng/api/authentication-settings/saml-metadata](https://apidocs.harness.io/authentication-settings/uploadsamlmetadatads.md): Updates the SAML metadata for the given Account ID.

## Canny

This contains APIs required for the creation of Canny tickets

### create Canny Post for given user

 - [POST /ng/api/canny/post](https://apidocs.harness.io/canny/createcannypost.md)

### create Canny Post for given user

 - [POST /ng/api/canny/postV2](https://apidocs.harness.io/canny/createcannypostv2.md)

### Get a list of boards available on Canny

 - [GET /ng/api/canny/boards](https://apidocs.harness.io/canny/getcannyboards.md)

### Get a list of categories available for a board in Canny

 - [GET /ng/api/canny/categories](https://apidocs.harness.io/canny/getcannyboards_1.md)

## Devops Essentials License Data By Account

### Get subscriptions information for the Devops Essentials package for an accountIdentifier.

 - [GET /v1/subscription/devops/{accountIdentifier}](https://apidocs.harness.io/devops-essentials-license-data-by-account/get-devops-essentials-license.md)

## EULA [Beta]

This contains APIs for EULA.

### Sign an End User License Agreement

 - [POST /v1/eula/sign](https://apidocs.harness.io/eula/sign-eula.md): Sign an End User License Agreement.

### Validate specified agreement is signed or not

 - [GET /v1/eula/validate-sign](https://apidocs.harness.io/eula/validate-eula-sign.md): Check whether End User License Agreement has been signed for specified agreement type.

## Filter

This contains APIs related to Filter as defined in Harness

### List Filters

 - [GET /ng/api/filters](https://apidocs.harness.io/filter/getfilterlist.md): Lists Filters for the given criteria.

### Update a Filter

 - [PUT /ng/api/filters](https://apidocs.harness.io/filter/updatefilter.md): Updates the filter for the given ID.

### Create a Filter

 - [POST /ng/api/filters](https://apidocs.harness.io/filter/postfilter.md): Creates a Filter.

### Return Filter Details

 - [GET /ng/api/filters/{identifier}](https://apidocs.harness.io/filter/getfilter.md): Returns the settings of a filter for the given ID.

### Delete a Filter

 - [DELETE /ng/api/filters/{identifier}](https://apidocs.harness.io/filter/deletefilter.md): Deletes a filter for the given ID.

### List Filters

 - [GET /pipeline/api/filters](https://apidocs.harness.io/filter/pipelinegetfilterlist.md): Lists Filters for the given criteria.

### Update a Filter

 - [PUT /pipeline/api/filters](https://apidocs.harness.io/filter/pipelineupdatefilter.md): Updates the filter for the given ID.

### Create a Filter

 - [POST /pipeline/api/filters](https://apidocs.harness.io/filter/pipelinepostfilter.md): Creates a Filter.

### Return Filter Details

 - [GET /pipeline/api/filters/{identifier}](https://apidocs.harness.io/filter/pipelinegetfilter.md): Returns the settings of a filter for the given ID.

### Delete a Filter

 - [DELETE /pipeline/api/filters/{identifier}](https://apidocs.harness.io/filter/pipelinedeletefilter.md): Deletes a filter for the given ID.

### List Filters

 - [GET /ccm/api/filters](https://apidocs.harness.io/filter/ccmgetfilterlist.md): Lists Filters for the given criteria.

### Update a Filter

 - [PUT /ccm/api/filters](https://apidocs.harness.io/filter/ccmupdatefilter.md): Updates the filter for the given ID.

### Create a Filter

 - [POST /ccm/api/filters](https://apidocs.harness.io/filter/ccmpostfilter.md): Creates a Filter.

### Return Filter Details

 - [GET /ccm/api/filters/{identifier}](https://apidocs.harness.io/filter/ccmgetfilter.md): Returns the settings of a filter for the given ID.

### Delete a Filter

 - [DELETE /ccm/api/filters/{identifier}](https://apidocs.harness.io/filter/ccmdeletefilter.md): Deletes a filter for the given ID.

### List Filters

 - [GET /template/api/filters](https://apidocs.harness.io/filter/templategetfilterlist.md): Lists Filters for the given criteria.

### Update a Filter

 - [PUT /template/api/filters](https://apidocs.harness.io/filter/templateupdatefilter.md): Updates the filter for the given ID.

### Create a Filter

 - [POST /template/api/filters](https://apidocs.harness.io/filter/templatepostfilter.md): Creates a Filter.

### Return Filter Details

 - [GET /template/api/filters/{identifier}](https://apidocs.harness.io/filter/templategetfilter.md): Returns the settings of a filter for the given ID.

### Delete a Filter

 - [DELETE /template/api/filters/{identifier}](https://apidocs.harness.io/filter/templatedeletefilter.md): Deletes a filter for the given ID.

## Harness Resource Type

This contains APIs related to Harness Resource Type

### Gets all resource types available at this scope

 - [GET /authz/api/resourcetype](https://apidocs.harness.io/harness-resource-type/getresourcetypes.md)

## Invite

This contains APIs related to Invite as defined in Harness

### Resend invite

 - [PUT /ng/api/invites/{inviteId}](https://apidocs.harness.io/invite/updateinvite.md): Resend the invite email

### Delete Invite

 - [DELETE /ng/api/invites/{inviteId}](https://apidocs.harness.io/invite/deleteinvite.md): Delete an Invite by Identifier

### Get Invite

 - [GET /ng/api/invites/invite](https://apidocs.harness.io/invite/getinvite.md): Gets an Invite by either Invite Id or JwtToken

### List Invites

 - [GET /ng/api/invites](https://apidocs.harness.io/invite/getinvites.md): List all the Invites for a Project or Organization

### Get pending users

 - [POST /ng/api/invites/aggregate](https://apidocs.harness.io/invite/getpendingusersaggregated.md): List of all the pending users in a scope

## IP Allowlist [Beta]

This contains APIs for IP Allowlist.

### Create a IP Allowlist config

 - [POST /v1/ip-allowlist](https://apidocs.harness.io/ip-allowlist/create-ip-allowlist-config.md): Creates a new IP Allowlist config

### List IP Allowlist Configs

 - [GET /v1/ip-allowlist](https://apidocs.harness.io/ip-allowlist/get-ip-allowlist-configs.md): Retrieves the information of the IP Allowlist Config

### Retrieve a IP Allowlist config

 - [GET /v1/ip-allowlist/{ip-config-identifier}](https://apidocs.harness.io/ip-allowlist/get-ip-allowlist-config.md): Retrieves the specified IP Allowlist config

### Update IP Allowlist config

 - [PUT /v1/ip-allowlist/{ip-config-identifier}](https://apidocs.harness.io/ip-allowlist/update-ip-allowlist-config.md): Updates the specified IP Allowlist config

### Delete an IP Allowlist config

 - [DELETE /v1/ip-allowlist/{ip-config-identifier}](https://apidocs.harness.io/ip-allowlist/delete-ip-allowlist-config.md): Deletes the specified IP Allowlist config

### Validate unique IP Allowlist config identifier

 - [GET /v1/ip-allowlist/validate-unique-identifier/{ip-config-identifier}](https://apidocs.harness.io/ip-allowlist/validate-unique-ip-allowlist-config-identifier.md): Checks whether the IP Allowlist config identifier is unique or not

### Validate IP address lies in a specified range or not

 - [GET /v1/ip-allowlist/validate/ip-address](https://apidocs.harness.io/ip-allowlist/validate-ip-address-allowlisted-or-not.md): Checks whether the IP address is allowed or not. It also supports checking against a specific IP block range.

### Check if IP address is allowed or not

 - [GET /v1/ip-allowlist/allowed/ip-address](https://apidocs.harness.io/ip-allowlist/allowed-ip-address.md): Checks whether the IP address is allowed or not.

## Nextgen Ldap

This contains APIs related to Nextgen Ldap as defined in Harness

### Get the NgLdap Setting

 - [GET /ng/api/ldap/ngLdapSettings](https://apidocs.harness.io/nextgen-ldap/getngldapsettings.md): For the given accountId fetch and return the ng ldap settings

### Test LDAP authentication

 - [POST /ng/api/ldap/ldap-login-test](https://apidocs.harness.io/nextgen-ldap/postldapauthenticationtest.md): Tests LDAP authentication for the given Account ID, with a valid test email and password

### Return Ldap groups matching name

 - [GET /ng/api/ldap/{ldapId}/search/group](https://apidocs.harness.io/nextgen-ldap/searchldapgroups.md): Returns all userGroups for the configured Ldap in the account matching a given name.

## Notification Channels

This contains APIs for Notification Channels

### List Notification channels

 - [GET /v1/orgs/{org}/projects/{project}/notification-channels](https://apidocs.harness.io/notification-channels/list-notification-channels.md): Returns a list of notification channels for the scope.

### Create Notification channel

 - [POST /v1/orgs/{org}/projects/{project}/notification-channels](https://apidocs.harness.io/notification-channels/create-notification-channel.md): Create Notification Channel

### Get Notification channel

 - [GET /v1/orgs/{org}/projects/{project}/notification-channels/{notification-channel}](https://apidocs.harness.io/notification-channels/get-notification-channel.md): Get Notification Channel

### Delete Notification Channel

 - [DELETE /v1/orgs/{org}/projects/{project}/notification-channels/{notification-channel}](https://apidocs.harness.io/notification-channels/delete-notification-channel.md): Delete notification channel

### Update Notification Channel

 - [PUT /v1/orgs/{org}/projects/{project}/notification-channels/{notification-channel}](https://apidocs.harness.io/notification-channels/update-notification-channel.md): Update Notification Channel

### List Notification channels at org level

 - [GET /v1/orgs/{org}/notification-channels](https://apidocs.harness.io/notification-channels/list-notification-channels-org.md): Returns a list of notification channels for the scope.

### Create Notification channel

 - [POST /v1/orgs/{org}/notification-channels](https://apidocs.harness.io/notification-channels/create-notification-channel-org.md): Create Notification Channel

### List Notification channels at account level

 - [GET /v1/notification-channels](https://apidocs.harness.io/notification-channels/list-notification-channels-account.md): Returns a list of notification channels for the scope.

### Create Notification channel

 - [POST /v1/notification-channels](https://apidocs.harness.io/notification-channels/create-notification-channel-account.md): Create Notification Channel

### Get Notification channel

 - [GET /v1/orgs/{org}/notification-channels/{notification-channel}](https://apidocs.harness.io/notification-channels/get-notification-channel-org.md): Get Notification Channel

### Delete Notification Channel

 - [DELETE /v1/orgs/{org}/notification-channels/{notification-channel}](https://apidocs.harness.io/notification-channels/delete-notification-channel-org.md): Delete notification channel

### Update Notification Channel

 - [PUT /v1/orgs/{org}/notification-channels/{notification-channel}](https://apidocs.harness.io/notification-channels/update-notification-channel-org.md): Update Notification Channel

### Get Notification channel

 - [GET /v1/notification-channels/{notification-channel}](https://apidocs.harness.io/notification-channels/get-notification-channel-account.md): Get Notification Channel

### Delete Notification Channel

 - [DELETE /v1/notification-channels/{notification-channel}](https://apidocs.harness.io/notification-channels/delete-notification-channel-account.md): Delete notification channel

### Update Notification Channel

 - [PUT /v1/notification-channels/{notification-channel}](https://apidocs.harness.io/notification-channels/update-notification-channel-account.md): Update Notification Channel

### Validate unique identifier for notification channel

 - [GET /v1/orgs/{org}/validate-channels/{notification-channel}](https://apidocs.harness.io/notification-channels/validate-notification-channel-identifier-org.md)

### Validate Notification Channel Identifier

 - [GET /v1/orgs/{org}/projects/{project}/validate-channels/{notification-channel}](https://apidocs.harness.io/notification-channels/validate-notification-channel-identifier.md)

### Validate Notification channel identifier

 - [GET /v1/validate-channels/{notification-channel}](https://apidocs.harness.io/notification-channels/validate-notification-channel-identifier-account.md): Validate Notification Channel Indetifier

## Notification Rules

This contains APIs for Notification Rules

### List Notification rules

 - [GET /v1/orgs/{org}/projects/{project}/notification-rules](https://apidocs.harness.io/notification-rules/list-notification-rules.md): Get list of notification rules

### Create Notification Rule

 - [POST /v1/orgs/{org}/projects/{project}/notification-rules](https://apidocs.harness.io/notification-rules/create-notification-rule.md): Create Notification Rule

### Get Notification Rule

 - [GET /v1/orgs/{org}/projects/{project}/notification-rules/{notification-rule}](https://apidocs.harness.io/notification-rules/get-notification-rule.md): Get notification rule

### Delete Notification Rule

 - [DELETE /v1/orgs/{org}/projects/{project}/notification-rules/{notification-rule}](https://apidocs.harness.io/notification-rules/delete-notification-rule.md): Delete notification rule

### Update Notification Rule

 - [PUT /v1/orgs/{org}/projects/{project}/notification-rules/{notification-rule}](https://apidocs.harness.io/notification-rules/update-notification-rule.md): Update Notification Rule

### List Notification rules at org level

 - [GET /v1/orgs/{org}/notification-rules](https://apidocs.harness.io/notification-rules/list-notification-rules-org.md): Get list of notification rules

### Create Notification Rule

 - [POST /v1/orgs/{org}/notification-rules](https://apidocs.harness.io/notification-rules/create-notification-rule-org.md): Create Notification Rule

### List Notification rules at account level

 - [GET /v1/notification-rules](https://apidocs.harness.io/notification-rules/list-notification-rules-account.md): Get list of notification rules for account

### Create Notification Rule

 - [POST /v1/notification-rules](https://apidocs.harness.io/notification-rules/create-notification-rule-account.md): Create Notification Rule

### Get Notification Rule

 - [GET /v1/orgs/{org}/notification-rules/{notification-rule}](https://apidocs.harness.io/notification-rules/get-notification-rule-org.md): Get notification rule

### Delete Notification Rule

 - [DELETE /v1/orgs/{org}/notification-rules/{notification-rule}](https://apidocs.harness.io/notification-rules/delete-notification-rule-org.md): Delete notification rule

### Update Notification Rule

 - [PUT /v1/orgs/{org}/notification-rules/{notification-rule}](https://apidocs.harness.io/notification-rules/update-notification-rule-org.md): Update Notification Rule

### Get Notification Rule

 - [GET /v1/notification-rules/{notification-rule}](https://apidocs.harness.io/notification-rules/get-notification-rule-account.md): Get notification rule

### Delete Notification Rule

 - [DELETE /v1/notification-rules/{notification-rule}](https://apidocs.harness.io/notification-rules/delete-notification-rule-account.md): Delete notification rule

### Update Notification Rule

 - [PUT /v1/notification-rules/{notification-rule}](https://apidocs.harness.io/notification-rules/update-notification-rule-account.md): Update Notification Rule

### Validate notification rule identifier

 - [GET /v1/orgs/{org}/projects/{project}/notification-rules/validate-rules/{notification-rule}](https://apidocs.harness.io/notification-rules/validate-notification-rule-identifier.md): Validate notification rule identifier

### Validate notification rule identifier

 - [GET /v1/orgs/{org}/validate-rules/{notification-rule}](https://apidocs.harness.io/notification-rules/validate-notification-rule-identifier-org.md): Validate notification rule identifier org level

### Validate notification rule identifier

 - [GET /v1/validate-rules/{notification-rule}](https://apidocs.harness.io/notification-rules/validate-notification-rule-identifier-account.md): Validate notification rule identifier

### List of notification entities and events

 - [GET /v1/notification-resource-list](https://apidocs.harness.io/notification-rules/notification-resource-list.md)

## OIDC

This contains APIs related to the Harness OIDC config

### Get the openid configuration for Harness

 - [GET /ng/api/oidc/account/{accountId}/.wellknown/jwks](https://apidocs.harness.io/oidc/getharnessopenidconfig.md)

### Get the openid configuration for Harness

 - [GET /ng/api/oidc/account/{accountId}/.well-known/openid-configuration](https://apidocs.harness.io/oidc/getharnessopenidconfig_1.md)

## Oidc-Access-Token

This contains APIs related to OIDC Access Token generation as defined in Harness

### Generate an OIDC IAM Role Credential for AWS

 - [POST /ng/api/oidc/access-token/aws/webidentity-session-access](https://apidocs.harness.io/oidc-access-token/generateoidciamrolecredentialforaws.md)

### Generates an OIDC Service Account Access Token for GCP

 - [POST /ng/api/oidc/access-token/gcp/service-account-access](https://apidocs.harness.io/oidc-access-token/getoidcserviceaccountaccesstokenforgcp.md)

### Exchanges an OIDC token for Azure credentials

 - [POST /ng/api/oidc/access-token/azure](https://apidocs.harness.io/oidc-access-token/exchangeoidctokenforazurecredentials.md)

### Generates an OIDC Workload Access Token for GCP

 - [POST /ng/api/oidc/access-token/gcp/workload-access](https://apidocs.harness.io/oidc-access-token/oidcworkloadaccesstokenresponse.md)

## Oidc-ID-Token

This contains APIs related to OIDC ID Token generation as defined in Harness

### Generates an OIDC ID Token for Azure

 - [POST /ng/api/oidc/id-token/azure](https://apidocs.harness.io/oidc-id-token/generateoidcidtokenforazure.md)

### Generates an OIDC ID Token for GCP

 - [POST /ng/api/oidc/id-token/gcp](https://apidocs.harness.io/oidc-id-token/generateoidcidtokenforgcp.md)

### Generates an OIDC ID Token for GCP

 - [POST /ng/api/oidc/id-token/gcp-v2](https://apidocs.harness.io/oidc-id-token/generateoidcidtokenforgcp_1.md)

### Generate a custom OIDC ID Token

 - [POST /ng/api/oidc/id-token/custom](https://apidocs.harness.io/oidc-id-token/generatecustomoidcidtoken.md)

### Generates an OIDC ID Token for AWS

 - [POST /ng/api/oidc/id-token/aws](https://apidocs.harness.io/oidc-id-token/generateoidcidtokenforaws.md)

## Org Webhooks

This contains APIs for Org Webhooks.

### Lists all the Webhooks at Org level

 - [POST /v1/orgs/{org}/webhooks/list](https://apidocs.harness.io/org-webhooks/list-org-webhooks.md): List org level webhooks

### Create a webhook at Org level

 - [POST /v1/orgs/{org}/webhooks](https://apidocs.harness.io/org-webhooks/create-org-webhooks.md): Create webhooks at org level

### Fetch Webhook at org level

 - [GET /v1/orgs/{org}/webhooks/{webhook}](https://apidocs.harness.io/org-webhooks/get-org-webhook.md): Fetch Webhook at org level

### Updates a Webhook at Org level

 - [PUT /v1/orgs/{org}/webhooks/{webhook}](https://apidocs.harness.io/org-webhooks/update-org-webhook.md): Updates a Webhook at Org level

### Deletes a Webhook at org level

 - [DELETE /v1/orgs/{org}/webhooks/{webhook}](https://apidocs.harness.io/org-webhooks/delete-org-webhook.md): Deletes a Webhook at org level

## Permissions

This contains the APIs related to permissions

### List Permissions

 - [GET /authz/api/permissions](https://apidocs.harness.io/permissions/getpermissionlist.md): Get all permissions in a scope or all permissions in the system

### List Resource Types

 - [GET /authz/api/permissions/resourcetypes](https://apidocs.harness.io/permissions/getpermissionresourcetypeslist.md): Get all resource types for permissions in a scope or in the system.

## Project Webhooks

This contains APIs for Project Webhooks.

### List all the Webhooks at Project level

 - [POST /v1/orgs/{org}/projects/{project}/webhooks/list](https://apidocs.harness.io/project-webhooks/list-project-webhooks.md): List project level webhooks

### Create a webhook at Project level

 - [POST /v1/orgs/{org}/projects/{project}/webhooks](https://apidocs.harness.io/project-webhooks/create-project-webhooks.md): Create webhooks at project level

### Fetch Webhook at project level

 - [GET /v1/orgs/{org}/projects/{project}/webhooks/{webhook}](https://apidocs.harness.io/project-webhooks/get-project-webhook.md): Fetch Webhook at project level

### Updates a Webhook at Project level

 - [PUT /v1/orgs/{org}/projects/{project}/webhooks/{webhook}](https://apidocs.harness.io/project-webhooks/update-project-webhook.md): Updates a Webhook at Project level

### Deletes a Webhook at project level

 - [DELETE /v1/orgs/{org}/projects/{project}/webhooks/{webhook}](https://apidocs.harness.io/project-webhooks/delete-project-webhook.md): Deletes a Webhook at project level

## Secret Managers

This contains APIs related to SecretManagers as defined in Harness

### Gets the metadata of Secret Manager

 - [POST /ng/api/secret-managers/meta-data](https://apidocs.harness.io/secret-managers/getmetadata.md)

## Service Account

This has all the APIs specific to the Service Accounts in Harness.

### Get Service Accounts

 - [GET /ng/api/serviceaccount](https://apidocs.harness.io/service-account/listserviceaccount.md): Fetches list of Service Accounts for the given filter criteria.

### Create a Service Account

 - [POST /ng/api/serviceaccount](https://apidocs.harness.io/service-account/createserviceaccount.md): Creates a new Service Account.

### Update a Service Account

 - [PUT /ng/api/serviceaccount/{identifier}](https://apidocs.harness.io/service-account/updateserviceaccount.md): Updates details of the Service Account for the given Service Account ID.

### Delete a Service Account

 - [DELETE /ng/api/serviceaccount/{identifier}](https://apidocs.harness.io/service-account/deleteserviceaccount.md): Deletes a Service Account corresponding to the given Service Account ID.

### Get Service Account In Scope

 - [GET /ng/api/serviceaccount/aggregate/{identifier}](https://apidocs.harness.io/service-account/getaggregatedserviceaccount.md): Gets the list of Service Accounts in the given scope.

### Get Inheriting Child Scopes

 - [GET /ng/api/serviceaccount/{identifier}/scopes](https://apidocs.harness.io/service-account/getinheritingchildscopelistforserviceaccount.md): List the Child Scopes inheriting this User Group

### List aggregated Service Accounts

 - [GET /ng/api/serviceaccount/aggregate](https://apidocs.harness.io/service-account/listaggregatedserviceaccounts.md): Fetches the list of Aggregated Service Accounts corresponding to the request's filter criteria.

### List manageable Service Accounts

 - [GET /ng/api/serviceaccount/manageable](https://apidocs.harness.io/service-account/listmanageableserviceaccounts.md): Fetches the list of Service Accounts for which the user has manage API key permission.

## Setting

This contains APIs related to Settings as defined in Harness

### Get a setting value by identifier

 - [GET /ng/api/settings/{identifier}](https://apidocs.harness.io/setting/getsettingvalue.md)

### Get list of settings under the specified category

 - [GET /ng/api/settings](https://apidocs.harness.io/setting/getsettingslist.md)

### Update settings

 - [PUT /ng/api/settings](https://apidocs.harness.io/setting/updatesettingvalue.md)

## SMTP

This contains APIs related to SmtpConfig as defined in Harness

### Delete Smtp Config by identifier

 - [DELETE /ng/api/smtpConfig/{identifier}](https://apidocs.harness.io/smtp/deletesmtpconfig.md)

### Gets Smtp config by accountId

 - [GET /ng/api/smtpConfig](https://apidocs.harness.io/smtp/getsmtpconfig.md)

### Updates the Smtp Config

 - [PUT /ng/api/smtpConfig](https://apidocs.harness.io/smtp/updatesmtp.md)

### Creates SMTP config

 - [POST /ng/api/smtpConfig](https://apidocs.harness.io/smtp/createsmtpconfig.md)

### Tests the config's connectivity by sending a test email

 - [POST /ng/api/smtpConfig/validate-connectivity](https://apidocs.harness.io/smtp/validateconnectivity.md)

### Checks whether other connectors exist with the same name

 - [POST /ng/api/smtpConfig/validateName](https://apidocs.harness.io/smtp/validatename.md)

## Source Code Manager

Contains APIs related to Source Code Manager

### Updates Source Code Manager Details with the given Source Code Manager Id

 - [PUT /ng/api/source-code-manager/{identifier}](https://apidocs.harness.io/source-code-manager/updatesourcecodemanager.md)

### Deletes the Source Code Manager corresponding to the specified Source Code Manager Id

 - [DELETE /ng/api/source-code-manager/{identifier}](https://apidocs.harness.io/source-code-manager/deletesourcecodemanager.md)

### Lists Source Code Managers for the given account

 - [GET /ng/api/source-code-manager](https://apidocs.harness.io/source-code-manager/getsourcecodemanagers.md)

### Creates Source Code Manager

 - [POST /ng/api/source-code-manager](https://apidocs.harness.io/source-code-manager/createsourcecodemanager.md)

## Token

This contains APIs related to Token as defined in Harness

### Create a Token

 - [POST /ng/api/token](https://apidocs.harness.io/token/createtoken.md): Creates a Token for the given API Key Type.

### Update a Token

 - [PUT /ng/api/token/{identifier}](https://apidocs.harness.io/token/updatetoken.md): Updates a Token for the given API Key Type.

### Delete a Token

 - [DELETE /ng/api/token/{identifier}](https://apidocs.harness.io/token/deletetoken.md): Deletes a Token for the given API Key Type.

### List all Tokens

 - [GET /ng/api/token/aggregate](https://apidocs.harness.io/token/listaggregatedtokens.md): Lists all the Tokens matching the given search criteria.

### Rotate a Token

 - [POST /ng/api/token/rotate/{identifier}](https://apidocs.harness.io/token/rotatetoken.md): Rotates a Token for the given API Key Type.

### Validate a Token

 - [POST /ng/api/token/validate](https://apidocs.harness.io/token/validatetoken.md): Validate a Token for the given account.

### Token#IssueToken

 - [GET /sto/api/v2/token](https://apidocs.harness.io/token/token_issuetoken.md): Issue a cross-service token

### Issue a cross-service token

 - [GET /v1/token](https://apidocs.harness.io/token/token_issuetoken1.md): Issue a cross-service token

## User

This contains APIs related to User as defined in Harness

### Add user to user groups

 - [PUT /ng/api/user/add-user-to-groups/{userId}](https://apidocs.harness.io/user/addusertousergroups.md): Adds the user to the specified user group IDs passed in the body and removes all other user groups for user except harness managed user groups

### Add user(s) to scope

 - [POST /ng/api/user/users](https://apidocs.harness.io/user/addusers.md)

### Change user password

 - [PUT /ng/api/user/password](https://apidocs.harness.io/user/changeuserpassword.md): Updates the User password

### Check if user is last admin

 - [GET /ng/api/user/last-admin](https://apidocs.harness.io/user/checkiflastadmin.md): Check whether the user is last admin at scope or not

### Disable two factor authentication

 - [PUT /ng/api/user/disable-two-factor-auth](https://apidocs.harness.io/user/disablettwofactorauth.md): Disables two-factor-auth for an user in an account

### end impersonation session for user

 - [POST /ng/api/user/endImpersonation/{userId}](https://apidocs.harness.io/user/endimpersonation.md)

### Get detailed user information

 - [GET /ng/api/user/aggregate/{userId}](https://apidocs.harness.io/user/getaggregateduser.md): Returns the user metadata along with rolesAssignments by userId and scope

### Get list of users

 - [POST /ng/api/user/aggregate](https://apidocs.harness.io/user/getaggregatedusers.md): List of all the user's metadata along with rolesAssignments who have access to given scope

### Gets Two Factor Auth Settings

 - [GET /ng/api/user/two-factor-auth/{authMechanism}](https://apidocs.harness.io/user/gettwofactorauthsettings.md): Gets two factor authentication settings information of the current logged in user

### Get Current User Info

 - [GET /ng/api/user/currentUser](https://apidocs.harness.io/user/getcurrentuserinfo.md): Gets current logged in User information

### Get users list

 - [POST /ng/api/user/batch](https://apidocs.harness.io/user/getusers.md): Get list of user's for a given scope

### impersonate User

 - [POST /ng/api/user/impersonate/{userId}](https://apidocs.harness.io/user/impersonateuser.md)

### Update User

 - [PUT /ng/api/user/{userId}](https://apidocs.harness.io/user/updateuserinfo_1.md): Updates the User information

### Remove user from scope

 - [DELETE /ng/api/user/{userId}](https://apidocs.harness.io/user/removeuser.md): Remove user as the collaborator from the scope

### Reset two factor authorization

 - [GET /ng/api/user/reset-two-factor-auth/{userId}](https://apidocs.harness.io/user/reset2fa.md): Reset Two-Factor authorization.

### Unlock user

 - [PUT /ng/api/user/unlock-user/{userId}](https://apidocs.harness.io/user/unlockuser.md): unlock user in a given scope

### Enable two factor authentication

 - [PUT /ng/api/user/enable-two-factor-auth](https://apidocs.harness.io/user/enabletwofactorauth.md): Enables two-factor-auth for an user in an account

### Update User

 - [PUT /ng/api/user](https://apidocs.harness.io/user/updateuserinfo.md): Updates the User information

## User Group

This contains APIs related to User Group as defined in Harness

### Check user membership

 - [GET /ng/api/user-groups/{identifier}/member/{userIdentifier}](https://apidocs.harness.io/user-group/getmember.md): Check if the user is part of the user group in an account/org/project

### Add user to User Group

 - [PUT /ng/api/user-groups/{identifier}/member/{userIdentifier}](https://apidocs.harness.io/user-group/putmember.md): Add a user to the user group in an account/org/project

### Remove user from User Group

 - [DELETE /ng/api/user-groups/{identifier}/member/{userIdentifier}](https://apidocs.harness.io/user-group/deletemember.md): Remove a user from the user group in an account/org/project

### List the User Groups in an account/org/project

 - [GET /ng/api/user-groups](https://apidocs.harness.io/user-group/getusergrouplist.md): List User Groups

### Update User Group

 - [PUT /ng/api/user-groups](https://apidocs.harness.io/user-group/putusergroup.md): Update a User Group in an account/org/project

### Create User Group

 - [POST /ng/api/user-groups](https://apidocs.harness.io/user-group/postusergroup.md): Create a User Group in an account/org/project

### Get User Group

 - [GET /ng/api/user-groups/{identifier}](https://apidocs.harness.io/user-group/getusergroup.md): Get a User Group in an account/org/project

### Delete a User Group in an account/org/project

 - [DELETE /ng/api/user-groups/{identifier}](https://apidocs.harness.io/user-group/deleteusergroup.md): Delete User Group

### Get Inheriting Child Scopes

 - [GET /ng/api/user-groups/{identifier}/scopes](https://apidocs.harness.io/user-group/getinheritingchildscopelist.md): List the Child Scopes inheriting this User Group

### List users in User Group

 - [POST /ng/api/user-groups/{identifier}/users](https://apidocs.harness.io/user-group/getuserlistinusergroup.md): List the users in a User Group in an account/org/project

### Link LDAP Group to the User Group to an account/org/project

 - [PUT /ng/api/user-groups/{userGroupId}/link/ldap/{ldapId}](https://apidocs.harness.io/user-group/linkusergrouptoldap.md)

### Link OIDC Group to the User Group in an account/org/project

 - [PUT /ng/api/user-groups/{userGroupId}/link/oidc/{providerId}](https://apidocs.harness.io/user-group/linkusergrouptooidc.md)

### Link SAML Group to the User Group in an account/org/project

 - [PUT /ng/api/user-groups/{userGroupId}/link/saml/{samlId}](https://apidocs.harness.io/user-group/linkusergrouptosaml.md)

### List User Groups by filter

 - [POST /ng/api/user-groups/batch](https://apidocs.harness.io/user-group/getbatchusersgrouplist.md): List the User Groups selected by a filter in an account/org/project. This api supports maximum of 10K User Group in response.

### Get filtered User Groups

 - [POST /ng/api/user-groups/filter](https://apidocs.harness.io/user-group/getfilteredusergroupslist.md): List the User Groups selected by a filter in an account/org/project

### Unlink SSO Group from the User Group in an account/org/project

 - [PUT /ng/api/user-groups/{userGroupId}/unlink](https://apidocs.harness.io/user-group/unlinkusergroupfromsso.md)

### Update User Group

 - [PUT /ng/api/v2/user-groups](https://apidocs.harness.io/user-group/putusergroupv2.md): Update a User Group in an account/org/project

### Create User Group

 - [POST /ng/api/v2/user-groups](https://apidocs.harness.io/user-group/postusergroupv2.md): Create a User Group in an account/org/project

### Get User Group

 - [GET /ng/api/v2/user-groups/{identifier}](https://apidocs.harness.io/user-group/getusergroupv2.md): Get a User Group in an account/org/project

### Copy User Group (deprecated)

 - [PUT /ng/api/user-groups/copy](https://apidocs.harness.io/user-group/copyusergroup.md): Copy a User Group in an account/org/project

## Variables

This contains APIs related to Variables as defined in Harness.

### Fetches the list of Variables.

 - [GET /ng/api/variables](https://apidocs.harness.io/variables/getvariablelist.md)

### Updates the Variable.

 - [PUT /ng/api/variables](https://apidocs.harness.io/variables/updatevariable.md)

### Creates a Variable.

 - [POST /ng/api/variables](https://apidocs.harness.io/variables/createvariable.md)

### Get the Variable by scope identifiers and variable identifier.

 - [GET /ng/api/variables/{identifier}](https://apidocs.harness.io/variables/getvariable.md)

### Deletes Variable by ID.

 - [DELETE /ng/api/variables/{identifier}](https://apidocs.harness.io/variables/deletevariable.md)

### Get list of  Variable by scope identifiers and variable identifiers.

 - [POST /ng/api/variables/list](https://apidocs.harness.io/variables/listvariable.md)

## Agent mTLS Endpoint Management

Contains APIs related to Agent mTLS Endpoint management.

### Gets the agent mTLS endpoint for an account.

 - [GET /ng/api/agent/mtls/endpoint](https://apidocs.harness.io/agent-mtls-endpoint-management/getagentmtlsendpointforaccount.md)

### Updates the existing agent mTLS endpoint for an account.

 - [PUT /ng/api/agent/mtls/endpoint](https://apidocs.harness.io/agent-mtls-endpoint-management/updateagentmtlsendpointforaccount.md)

### Creates the agent mTLS endpoint for an account.

 - [POST /ng/api/agent/mtls/endpoint](https://apidocs.harness.io/agent-mtls-endpoint-management/createagentmtlsendpointforaccount.md)

### Removes the agent mTLS endpoint for an account.

 - [DELETE /ng/api/agent/mtls/endpoint](https://apidocs.harness.io/agent-mtls-endpoint-management/deleteagentmtlsendpointforaccount.md)

### Updates selected properties of the existing agent mTLS endpoint for an account.

 - [PATCH /ng/api/agent/mtls/endpoint](https://apidocs.harness.io/agent-mtls-endpoint-management/patchagentmtlsendpointforaccount.md)

### Checks whether a given agent mTLS endpoint domain prefix is available.

 - [GET /ng/api/agent/mtls/check-availability](https://apidocs.harness.io/agent-mtls-endpoint-management/checkagentmtlsendpointdomainprefixavailability.md)

## Delegate Download Resource

Contains APIs related to Downloading Delegates

### Downloads a docker delegate yaml file.

 - [POST /ng/api/download-delegates/docker](https://apidocs.harness.io/delegate-download-resource/downloaddockerdelegateyaml.md)

### Downloads a kubernetes delegate yaml file.

 - [POST /ng/api/download-delegates/kubernetes](https://apidocs.harness.io/delegate-download-resource/downloadkubernetesdelegateyaml.md)

## Delegate Group Tags Resource

Contains APIs related to Delegate Group Tags management

### Retrieves list of tags attached with Delegate group

 - [GET /ng/api/delegate-group-tags/{groupIdentifier}](https://apidocs.harness.io/delegate-group-tags-resource/listtagsfordelegategroup.md)

### Clears all existing tags with delegate group and attach given set of tags to delegate group.

 - [PUT /ng/api/delegate-group-tags/{groupIdentifier}](https://apidocs.harness.io/delegate-group-tags-resource/updatetagsofdelegategroup.md)

### Add given list of tags to the Delegate group

 - [POST /ng/api/delegate-group-tags/{groupIdentifier}](https://apidocs.harness.io/delegate-group-tags-resource/addtagstodelegategroup.md)

### Deletes all tags from the Delegate group

 - [DELETE /ng/api/delegate-group-tags/{groupIdentifier}](https://apidocs.harness.io/delegate-group-tags-resource/deletetagsfromdelegategroup.md)

### List delegate groups that are having mentioned tags.

 - [POST /ng/api/delegate-group-tags/delegate-groups](https://apidocs.harness.io/delegate-group-tags-resource/listdelegategroupsusingtags.md)

## Delegate Setup Resource

Contains Delegate Setup APIs

### Deletes a Delegate by its identifier.

 - [DELETE /ng/api/delegate-setup/delegate/{delegateIdentifier}](https://apidocs.harness.io/delegate-setup-resource/deletedelegate.md)

### Delete delegate image tag override

 - [DELETE /ng/api/delegate-setup/delete-delegate-override](https://apidocs.harness.io/delegate-setup-resource/overridedelegateimagetag.md)

### Generates delegate terraform example module file from the account

 - [GET /ng/api/delegate-setup/delegate-terraform-module-file](https://apidocs.harness.io/delegate-setup-resource/generateterraformmodule.md)

### Generates helm values yaml file from the data specified in request body (Delegate setup details).

 - [POST /ng/api/delegate-setup/generate-helm-values](https://apidocs.harness.io/delegate-setup-resource/generatenghelmvaluesyaml.md)

### Lists all delegates overrides in NG filtered by provided conditions

 - [GET /ng/api/delegate-setup/override-delegate-tag](https://apidocs.harness.io/delegate-setup-resource/listoverridedelegateimagetag.md)

### Overrides delegate image tag for account

 - [PUT /ng/api/delegate-setup/override-delegate-tag](https://apidocs.harness.io/delegate-setup-resource/overridedelegateimagetag_1.md)

### Lists all delegates in NG filtered by provided conditions

 - [POST /ng/api/delegate-setup/listDelegates](https://apidocs.harness.io/delegate-setup-resource/listdelegates.md)

### Gets the latest supported delegate version. The version has YY.MM.XXXXX format. You can use any version lower than the returned results(upto 3 months old)

 - [GET /ng/api/delegate-setup/latest-supported-version](https://apidocs.harness.io/delegate-setup-resource/publisheddelegateversion.md)

## Delegate Token Resource

Contains APIs related to Delegate Token management

### Retrieves Delegate Tokens by Account, Organization, Project and status.

 - [GET /ng/api/delegate-token-ng](https://apidocs.harness.io/delegate-token-resource/getcgdelegatetokens.md)

### Revokes Delegate Token.

 - [PUT /ng/api/delegate-token-ng](https://apidocs.harness.io/delegate-token-resource/revokecgdelegatetoken.md)

### Creates Delegate Token.

 - [POST /ng/api/delegate-token-ng](https://apidocs.harness.io/delegate-token-resource/createdelegatetoken.md)

### Deletes a revoked Delegate Token.

 - [DELETE /ng/api/delegate-token-ng](https://apidocs.harness.io/delegate-token-resource/deletengdelegatetoken.md)

### Lists delegate groups that are using the specified delegate token.

 - [GET /ng/api/delegate-token-ng/delegate-groups](https://apidocs.harness.io/delegate-token-resource/getdelegategroupsusingtoken.md)

## Pipelines [Beta]

This contains APIs for performing CRUD operations on Pipelines.

### List Pipelines

 - [GET /v1/orgs/{org}/projects/{project}/pipelines](https://apidocs.harness.io/pipelines/list-pipelines.md): Returns a list of Pipelines.

### Create a Pipeline

 - [POST /v1/orgs/{org}/projects/{project}/pipelines](https://apidocs.harness.io/pipelines/create-pipeline.md): Creates a Pipeline.

### Retrieve a Pipeline

 - [GET /v1/orgs/{org}/projects/{project}/pipelines/{pipeline}](https://apidocs.harness.io/pipelines/get-pipeline.md): Retrieves a Pipeline.

### Update a Pipeline

 - [PUT /v1/orgs/{org}/projects/{project}/pipelines/{pipeline}](https://apidocs.harness.io/pipelines/update-pipeline.md): Updates a Pipeline.

### Delete a Pipeline

 - [DELETE /v1/orgs/{org}/projects/{project}/pipelines/{pipeline}](https://apidocs.harness.io/pipelines/delete-pipeline.md): Deletes a Pipeline.

### Patch API for pipeline

 - [PATCH /v1/orgs/{org}/projects/{project}/pipelines/{pipeline}](https://apidocs.harness.io/pipelines/patch-pipeline.md): Patch API for pipeline

### Start a Pipeline Validation Event

 - [POST /v1/orgs/{org}/projects/{project}/pipelines/{pipeline}/validate](https://apidocs.harness.io/pipelines/start-pipeline-validation-event.md): Starts a Pipeline Validation Event and returns the UUID of the Event created

### Get Pipeline Validation Result

 - [GET /v1/orgs/{org}/projects/{project}/pipelines/validate/{uuid}](https://apidocs.harness.io/pipelines/get-pipeline-validate-result.md): Get Pipeline Validation Result for given UUID

### Move Pipeline YAML from inline to remote

 - [POST /v1/orgs/{org}/projects/{project}/pipelines/{pipeline}/move-config](https://apidocs.harness.io/pipelines/moveconfig.md): Creates a remote entity by fetching pipeline YAML from Harness.

### Get Pipeline YAML from Git Repository

 - [POST /v1/orgs/{org}/projects/{project}/pipelines/{pipeline}/import](https://apidocs.harness.io/pipelines/importpipelinefromgit.md): Fetches Pipeline YAML from Git Repository and saves a record for it in Harness

### Update GitMetadata for Remote Pipelines

 - [PUT /v1/orgs/{org}/projects/{project}/pipelines/{pipeline}/git-metadata](https://apidocs.harness.io/pipelines/update-pipeline-git-metadata.md): Update git-metadata in remote pipeline

### Get inputs schema details

 - [GET /v1/orgs/{org}/projects/{project}/pipelines/{pipeline}/inputs-schema](https://apidocs.harness.io/pipelines/get-inputs-schema-details.md)

## Input Sets [Beta]

This contains APIs for Input Sets.

### Create an Input Set

 - [POST /v1/orgs/{org}/projects/{project}/input-sets](https://apidocs.harness.io/input-sets/create-input-set.md): Creates an Input Set for a Pipeline.

### List Input Sets

 - [GET /v1/orgs/{org}/projects/{project}/input-sets](https://apidocs.harness.io/input-sets/list-input-sets.md): Returns a List of Input Sets for a Pipeline.

### Retrieve an Input Set

 - [GET /v1/orgs/{org}/projects/{project}/input-sets/{input-set}](https://apidocs.harness.io/input-sets/get-input-set.md): Retrieves an Input Set for a Pipeline.

### Update an Input Set

 - [PUT /v1/orgs/{org}/projects/{project}/input-sets/{input-set}](https://apidocs.harness.io/input-sets/update-input-set.md): Updates an Input Set for a Pipeline.

### Delete an Input Set

 - [DELETE /v1/orgs/{org}/projects/{project}/input-sets/{input-set}](https://apidocs.harness.io/input-sets/delete-input-set.md): Deletes an Input Set for a Pipeline.

### Move InputSet YAML from inline to remote

 - [POST /v1/orgs/{org}/projects/{project}/input-sets/{input-set}/move-config](https://apidocs.harness.io/input-sets/inputsetsmoveconfig.md): Creates a remote entity by fetching the input set YAML from Harness.

### Get Input Set YAML from Git Repository

 - [POST /v1/orgs/{org}/projects/{project}/input-sets/{input-set}/import](https://apidocs.harness.io/input-sets/importinputsetfromgit.md): Fetches InputSet YAML from Git Repository and saves a record for it in Harness

### Update GitMetadata for Remote InputSet

 - [PUT /v1/orgs/{org}/projects/{project}/input-sets/{input-set}/git-metadata](https://apidocs.harness.io/input-sets/update-input-set-git-metadata.md): Update git-metadata in remote inputSet and return the updated inputSet

### merged-input-sets

 - [POST /v1/orgs/{org}/projects/{project}/input-sets/merge](https://apidocs.harness.io/input-sets/merged-input-sets.md): Gets merged input sets

## Approvals

This contains APIs for Approvals.

### Gets Approval Instances by Execution Id

[...]
